"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = (parent, parameters, ctx) => __awaiter(void 0, void 0, void 0, function* () {
    var _a, _b;
    const dataRequest = parent.searchkit.dataRequest;
    try {
        const from = ((_a = parameters.page) === null || _a === void 0 ? void 0 : _a.from) || 0;
        const size = ((_b = parameters.page) === null || _b === void 0 ? void 0 : _b.size) || 10;
        dataRequest.setHits({
            size,
            from,
            sortId: parameters.sortBy
        });
        const { hits, sortedBy } = yield dataRequest.search();
        return {
            items: hits.items.map((item) => (Object.assign(Object.assign({}, item), { type: parent.searchkit.hitType }))),
            page: hits.page,
            sortedBy
        };
    }
    catch (e) {
        throw e;
    }
});
