import { SearchkitConfig } from '@searchkit/sdk';
import { SearchkitResponse } from '@searchkit/sdk';
declare type FacetsRequest = {
    identifier: string;
    query?: string;
    size?: number;
}[];
export declare class DataRequest {
    private config;
    private dataloader;
    private facets;
    private facetsCriteria;
    private size;
    private from;
    private skRequest;
    private baseFilters;
    constructor(config: SearchkitConfig);
    setFacets(enable: boolean): void;
    setFacetsCriteria(facetsCriteria: FacetsRequest): void;
    setHits({ size, from, sortId }: {
        size: number;
        from: number;
        sortId: string;
    }): void;
    setQuery(query: string): void;
    setBaseFilters(baseFilters: any): void;
    setFilters(filters: any): void;
    setQueryOptions(options: any): void;
    search(): Promise<SearchkitResponse>;
    performSearch(requests: any): Promise<any>;
}
declare const _default: (parent: any, parameters: any, ctx: any, info: any) => Promise<{
    searchkit: {
        dataRequest: DataRequest;
        config: SearchkitConfig;
        hitType: any;
    };
}>;
export default _default;
